#!/usr/bin/sh

# start basic services
mongod --bind_ip 127.0.0.1 --dbpath ~/data &
R CMD Rserve --vanilla &

# import data
echo "Importing data and validating models"
ruby -e "require 'lazar'; include OpenTox; Import.public_data if Model::Validation.all.empty?" 
# get PubChem cids in advance to avoid timeout issues
echo "Importing PubChem CID's"
ruby -e "require 'lazar'; include OpenTox; Compound.all.each{|c| c.cid}"

# start lazar service
cd `ls -d $(gem environment gemdir)/gems/lazar-gui-*`
unicorn -p 8088 -E production
